Running LegacyWorlds Beta 5 in 2025
===================================

This repo contains an attempt at running
[LWB5](https://git.nocternity.net/tseeker/lwb5) on a modern system. It is
based on Docker Compose, using three containers:

  * a PostgreSQL 17 container for the database,
  * a container for the game and its administration interface,
  * a final container that runs the planet picture generator.

The open proxy scanner as well as the IRC bot were removed as they do not
really make sense on the modern internet.

It is very likely to be broken in some areas because the code is outdated and,
while I fixed the most obvious problems, outdated syntax is likely to be hiding
in a few other places.

Running the game
----------------

In order to run LWB5, you have to:
- copy `docker/env.example` to `docker/.env` and edit the resulting file,
- start the application by running `docker compose up -d` inside the `docker/`
  directory,
- access the administration interface, which will be exposed on port 81,
- go to the `Ticks` page in the `Server management` section,
- select the `universe` tick for the `beta5` game and run it,
- now access the game itself on port 80 and log on using the administrative
  account configured in the `.env` file,
- go to `My account` and join the `Public Beta 5` game,
- go to the game's `Admin` page,
- click the `Manual update` link and wait.

Running the `universe` tick will start the planet picture generator. However, it
will take a while to run, so you'll see missing planet pictures until it's done
running.
